#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "randgen.h"
//#define mean0  0.0675553
#define eta0  0.0675553

//#define mean1 1.591241
#define eta1 1.591241

//#define variance0 1.059702
//#define variance1 1.059702
#define priorbeta0 1000
#define priorbeta1 1000

#define innerpart1 0.4718308

//number of iteration
#define NN 5000
//value of parameter
#define bb0 1.15
#define bb1 2.2
#define pi0 0.88
static int connectionMatrix[1000][1000]={0};

static int indicator[1000]={0};
double M;

main(){
    M = exp(-32*log(2.0));

   unsigned long* seed=initial_seed("seed.dat");

double prioralpha0,prioralpha1,testStat[1000],log0,log1,p0,mean0,mean1,variance0,variance1,normalmean0,normalmean1,normalvar0,normalvar1,all0,all1,laa0,laa1;
mean0=0.0675553;
mean1=1.591241;
variance0=1.059702;
variance1=1.059702;

int prob0,prob1,node,col;
//memset(connectionMatrix,0,sizeof connectionMatrix);
int (*pmatrix)[1000];
pmatrix=connectionMatrix;
//
//
for(int k=0;k<300;k=k+3) indicator[k]=1;

prioralpha0 = priorbeta0/variance0+1;
prioralpha1 = priorbeta1/variance1+1;

//read the data
FILE *tp;

tp = fopen("teststat_0.txt", "r");

  	for(int i=0; i<1000; i++)
		{fscanf(tp, "%lf\n",&testStat[i]);

		}
    	fclose(tp);
printf("%lf,%lf", testStat[0],testStat[999]);
//FILE *cmatrix;
//cmatrix = fopen("connection.txt", "rt");

//  	for(int i=0; i<1000; i++)
//  	for (int j=0; j<1000; j++)
//    connectionMatrix[i][j]=0;
//printf("%d", connectionMatrix[1][1]);
FILE *cmatrix;
cmatrix = fopen("conn.txt", "r");

 	for(int i=0; i<1000; i++){

  	  fscanf(tp, "%d %d\n",&edge1[i],&edge2[i]);
    connectionMatrix[edge1[i]][edge2[i]]=1;
    connectionMatrix[edge2[i]][edge1[i]]=1;

 	}
 	fclose(cmatrix);


		//fscanf(cmatrix, "%d\n",&(*(*(pmatrix+i)+j)));

    	//fclose(cmatrix);


FILE* fid = fopen("results_0.txt","wt");
clock_t start = clock();
//
for(int iter=0;iter<NN; iter++){
for(node=0; node<1000; node++){
prob0=0;
prob1=0;
for(col=0; col<1000; col++){
if(*(*(pmatrix+node)+col)==1){

if(*(indicator+col)==1){
prob1++;
}else{prob0++;}

}

}



log0=log(pi0)+(2*bb0*prob0-(testStat[node]-mean0)*(testStat[node]-mean0)*0.5/variance0);

log1=log(1-pi0)+(2*bb1*prob1-(testStat[node]-mean1)*(testStat[node]-mean1)*0.5/variance1);

p0 = 1/(1+exp(log1-log0));

double threshold=rand() / (double)RAND_MAX;
if(threshold<p0){
indicator[node]=0;
}else{
indicator[node]=1;
}
//update parameter
double statsum1=0.0;
double statsum0=0.0;

int indisum=0;

for(col=0; col<1000; col++){
if(*(indicator+col)==1){

statsum1=statsum1+(*(testStat+col));
indisum++;

}else{

statsum0=statsum0+(*(testStat+col));
}
}
normalmean0 = (variance0*eta0+0.0001*statsum0)/(variance0+0.0001*(1000-indisum));
normalmean1 = (variance1*eta1+0.0001*statsum1)/(variance1+0.0001*indisum);
normalvar0 = variance0*0.0001/(variance0+0.0001*(1000-indisum));
normalvar1 = variance1*0.0001/(variance1+0.0001*indisum);
mean0 = rnorm(normalmean0,sqrt(variance0),seed);
mean1 = rnorm(normalmean1,sqrt(variance1),seed);

double newstatsum1=0.0;
double newstatsum0=0.0;

for(col=0; col<1000; col++){
if(*(indicator+col)==1){

newstatsum1=newstatsum1+(*(testStat+col)-mean1)*(*(testStat+col)-mean1);


}else{

newstatsum0=newstatsum0+(*(testStat+col)-mean0)*(*(testStat+col)-mean0);
}
}


all0 = prioralpha0+(1000-indisum)*0.5;
laa0 = newstatsum0*0.5+priorbeta0;
all1 = prioralpha1+indisum*0.5;
laa1 = newstatsum1*0.5+priorbeta1;
variance0 = rinverse_gamma(all0,laa0,seed);
variance1 = rinverse_gamma(all1,laa1,seed);

// finish update



fprintf(fid,"%-3d",indicator[node]);
}
  fprintf(fid,"\n");

  	}

  	printf("Time elapsed: %f\n", ((double)clock() - start) / CLOCKS_PER_SEC);
fclose(fid);
return 0;
}
