## for the gaussian quadrature part

library(pscl)

library(tmvtnorm)


load("adjacency.bin")
aa<-matrix


load("simu10226.bin")

set.seed(1111)
testcov<-0
for(i in 1:1000){
if(newz[i]==0){
testcov[i]<-rnorm(1,mean=0,sd=0.2)

}else{
testcov[i]<-rnorm(1,mean=0.5,sd=0.2)

}
}



ww2<-0.8049141
ww1<-0.08131284
ww3<-0.8049141
ww4<-0.08131284
ww<-c(ww1,ww2,ww3,ww4)
xx1=-1.65068
xx2=-0.5246476
xx3= 0.5246476
xx4= 1.65068
xxx=c(xx1,xx2,xx3,xx4)

innerfunc=function(zz,rr){
if(zz==1){
ff1=(1+0.5*((rr-sqrt(2)*eta1*xx1-gamma1)^2)/beta1)^(-alpha1-0.5)
ff2=(1+0.5*((rr-sqrt(2)*eta1*xx2-gamma1)^2)/beta1)^(-alpha1-0.5)
ff3=(1+0.5*((rr-sqrt(2)*eta1*xx3-gamma1)^2)/beta1)^(-alpha1-0.5)
ff4=(1+0.5*((rr-sqrt(2)*eta1*xx4-gamma1)^2)/beta1)^(-alpha1-0.5)

outvalue=exp(lgamma(alpha1+0.5)-lgamma(alpha1))/sqrt(pi*beta1)

}else{
ff1=(1+0.5*((rr-sqrt(2)*eta0*xx1-gamma0)^2)/beta0)^(-alpha0-0.5)
ff2=(1+0.5*((rr-sqrt(2)*eta0*xx2-gamma0)^2)/beta0)^(-alpha0-0.5)
ff3=(1+0.5*((rr-sqrt(2)*eta0*xx3-gamma0)^2)/beta0)^(-alpha0-0.5)
ff4=(1+0.5*((rr-sqrt(2)*eta0*xx4-gamma0)^2)/beta0)^(-alpha0-0.5)

outvalue=exp(lgamma(alpha0+0.5)-lgamma(alpha0))/sqrt(pi*beta0)

}
ff<-c(ff1,ff2,ff3,ff4)
integralvalue=outvalue*(ww%*%ff)
return(integralvalue)
}


# gibbs  for mu and var

#gibbsfortheta<-function(initalmu,initalvar,index,nn){
#uprr=initalmu
#mymu=initalmu
#myvar=initalvar
#for(ii in 1:nn){
#if(index==0){
#meanforupmu=(myvar*gamma0+eta0^2*uprr)/(myvar+eta0^2)
#varforupmu=myvar*eta0^2/(myvar+eta0^2)
#
#mymu<-rnorm(1,mean=meanforupmu,sd=sqrt(varforupmu))
#
#all0<-alpha0+0.5
#laa0=(uprr-mymu)^2*0.5+beta0
#myvar<-rigamma(1,all0,laa0)
#
#}else{
#meanforupmu=(myvar*gamma1+eta1^2*uprr)/(myvar+eta1^2)
#varforupmu=myvar*eta1^2/(myvar+eta1^2)
#
#mymu<-rnorm(1,mean=meanforupmu,sd=sqrt(varforupmu))
#
#all1<-alpha1+0.5
#laa1=(uprr-mymu)^2*0.5+beta1
#myvar<-rigamma(1,all1,laa1)
#
#}
#
#}
#return(c(mymu,myvar))
#}
#

## giibs for mu ars for var


gibbsfortheta<-function(initalmu,initalvar,index){
uprr=initalmu
initialvarvar=initalvar

if(index==0){

  
myvar<-rigamma(1,alpha0,beta0)


meanforupmu=(myvar*gamma0+eta0^2*uprr)/(myvar+eta0^2)
varforupmu=myvar*eta0^2/(myvar+eta0^2)


mymu<-rnorm(1,mean=meanforupmu,sd=sqrt(varforupmu))


}else{


myvar<-rigamma(1,alpha1,beta1)



meanforupmu=(myvar*gamma1+eta1^2*uprr)/(myvar+eta1^2)
varforupmu=myvar*eta1^2/(myvar+eta1^2)

mymu<-rnorm(1,mean=meanforupmu,sd=sqrt(varforupmu))


}


return(c(mymu,myvar))
}
#
#
beta0=10
beta1=10
 
wholeindex<-rep(0,1000)
wholeindex[which(newz==1)]<-1
wholeindex[which(testcov>0.2082)]<-1
## assume less than 100 clusters
upmu<-rep(0,2)
upvar<-rep(0,2)
upmu[1]=mean(testcov[which(wholeindex==0)])
upmu[2]=mean(testcov[which(wholeindex==1)])
gamma0=0
gamma1=0.5

eta0<-0.06
eta1<-0.08

upvar[1]=var(testcov[which(wholeindex==0)])
upvar[2]=var(testcov[which(wholeindex==1)])

alpha0=beta0/0.04+1
alpha1=beta1/0.04+1

set.seed(1111)

method<-function(n,bb0,bb1,pi0,tau0,tau1){

total<-matrix(rep(NA,1000*n),ncol=1000,nrow=n)

for(jj in 1: n){
print(jj)
for(num1 in 1:1000){

uniqueindex<-sort(unique(wholeindex))
originalindex<-uniqueindex
sampleprob<-rep(NA,length(uniqueindex)+2)


idx = which(aa[num1,]==1)

pro0=sum((wholeindex[idx]<1))
pro1=sum((wholeindex[idx]>0))
 ## calculate mk
propro0=sum(wholeindex<1)
propro1=sum(wholeindex>0)


sumforg=0
uu<-0
for(gg in uniqueindex){
uu<-uu+1
sumforg[uu]<-sum(wholeindex==gg)-(wholeindex[num1]==gg)
if(gg<1){
sampleprob[uu+1]=log(pi0)+(2*bb0*pro0-(testcov[num1]-upmu[uu])^2*0.5/upvar[uu])-0.5*log(upvar[uu])+log(sumforg[uu])-log(tau0+propro0-1)

}else{
sampleprob[uu+1]=log(1-pi0)+(2*bb1*pro1-(testcov[num1]-upmu[uu])^2*0.5/upvar[uu])-0.5*log(upvar[uu])+log(sumforg[uu])-log(tau1+propro1-1)
}
}

test1whole=wholeindex

sampleprob[1]= log(pi0)+(2*bb0*pro0)+log(tau0)-log(tau0+propro0-1)+log(innerfunc(0,testcov[num1]))
sampleprob[length(uniqueindex)+2]= log(1-pi0)+(2*bb1*pro1)+log(tau1)-log(tau1+propro1-1)+log(innerfunc(1,testcov[num1]))
 newsampleprob<-0
for(uu in 1:length(sampleprob)){ newsampleprob[uu]=1/sum(exp(sampleprob-sampleprob[uu]))}
newsampleprob[which(newsampleprob=="NaN")]=0
origindex<-wholeindex[num1]
wholeindex[num1]=sample((min(wholeindex)-1):(max(wholeindex)+1),1,prob=newsampleprob)
sampleindex=wholeindex[num1]  


## check whether one cluster is disappear
myuniqueindex<-sort(unique(wholeindex))
if(sum(wholeindex==origindex)==0){

deletindex=which(originalindex==origindex)

upmu=upmu[-deletindex]
upvar=upvar[-deletindex]
if(origindex<1){
wholeindex[which(wholeindex<origindex)]=wholeindex[which(wholeindex<origindex)]+1
}else{

wholeindex[which(wholeindex>origindex)]=wholeindex[which(wholeindex>origindex)]-1

}
uniqueindex<-sort(unique(wholeindex))
if((sampleindex %in% originalindex)==0){
if(sampleindex<1){uniqueindex=uniqueindex[-1]}else{uniqueindex=uniqueindex[-length(uniqueindex)]}

}


}


test1mu=upmu
test1var=upvar
test1unique=uniqueindex

## update mu and variance part
uu=0
for(gg in (uniqueindex)){
uu=uu+1
if(gg <1){
meanforupmu=(upvar[uu]*gamma0+eta0^2*sum(testcov[which(wholeindex==gg)]))/(upvar[uu]+eta0^2*sum(wholeindex==gg))
varforupmu=upvar[uu]*eta0^2/(upvar[uu]+eta0^2*sum(wholeindex==gg))

upmu[uu]<-rnorm(1,mean=meanforupmu,sd=sqrt(varforupmu))
all0<-alpha0+sum(wholeindex==gg)*0.5
laa0<-sum((testcov[which(wholeindex==gg)]-upmu[uu])^2)*0.5+beta0
upvar[uu]<-rigamma(1,all0,laa0)

}else{
meanforupmu=(upvar[uu]*gamma1+eta1^2*sum(testcov[which(wholeindex==gg)]))/(upvar[uu]+eta1^2*sum(wholeindex==gg))
varforupmu=upvar[uu]*eta1^2/(upvar[uu]+eta1^2*sum(wholeindex==gg))

upmu[uu]<-rnorm(1,mean=meanforupmu,sd=sqrt(varforupmu))
all1<-alpha1+sum(wholeindex==gg)*0.5
laa1<-sum((testcov[which(wholeindex==gg)]-upmu[uu])^2)*0.5+beta1
upvar[uu]<-rigamma(1,all1,laa1)

}

}

if((sampleindex %in% originalindex)==0){
if(sampleindex==min(myuniqueindex)){

results=gibbsfortheta(testcov[num1],beta0/(alpha0+0.5),0)
newupmu=results[1]
newupvar=results[2]
upmu<-c(newupmu,upmu)
upvar<-c(newupvar,upvar)

}else if(sampleindex==max(myuniqueindex)){
results=gibbsfortheta(testcov[num1],beta1/(alpha1+0.5),1)
newupmu=results[1]
newupvar=results[2]
upmu<-c(upmu,newupmu)
upvar<-c(upvar,newupvar)

}
 }


## switch the label
uniqueindex<-sort(unique(wholeindex))
test2whole=wholeindex
test2mu=upmu
test2var=upvar

if(length(uniqueindex)>1){
orderindex=rank(upmu)
 ssupmu=0
 ssupvar=0
 sswholeindex<-rep(NA,1000)
 for(kk in 1:length(uniqueindex)){
  ssupmu[kk]=upmu[which(orderindex==kk)]
  ssupvar[kk]=upvar[which(orderindex==kk)]
    dudu=which(orderindex==kk)
  sswholeindex[which(wholeindex==uniqueindex[dudu])]=uniqueindex[kk]
  
  
 }
upmu=ssupmu
upvar=ssupvar
wholeindex=sswholeindex



}




}

total[jj,]<-wholeindex

}


return(total)
}


## use ars
#
#ff=function(sigmaG,alphak,betak,mygamma,myxi,rrvalue){-(1+alphak)*log(sigmaG)-0.5*log(myxi+sigmaG)+(myxi*rrvalue+sigmaG*mygamma)^2/2/sigmaG/myxi/(sigmaG+myxi)-betak/sigmaG-rrvalue^2/2/sigmaG}
#ffprima=function(sigmaG,alphak,betak,mygamma,myxi,rrvalue){-(1+alphak)/sigmaG-0.5/(myxi+sigmaG)+(myxi*rrvalue+sigmaG*mygamma)*(mygamma*sigmaG-2*sigmaG*rrvalue-myxi*rrvalue)/2/((sigmaG^2+myxi*sigmaG)^2)+(betak+rrvalue*0.5)/sigmaG/sigmaG}
#mysamplesigma<-ars(1,ff,ffprima,alphak=alpha0,betak=beta0,mygamma=gamma0,myxi=eta0,rrvalue=testcov[])