/*
 *  randgen.h
 *  mgp
 *
 */
#ifndef _RANDGEN_H_
#define _RANDGEN_H_


unsigned long * initial_seed(const char *);
unsigned long * initial_seed(unsigned long ,unsigned long ,unsigned long );
void save_seed(unsigned long*, const char*);
double kiss(unsigned long *);
int runiform_n(int,unsigned long *);
void permute_sample(double *,int,unsigned long *); 
void permute_sample_int(int *,int,unsigned long *); 
long rmultinomial(double *,long,unsigned long *);
double runif_atob(unsigned long *,double,double);
double rexp(double,unsigned long *);
double sgamma(double,unsigned long *);
double fsign(double,double);
double snorm(unsigned long *);
double snorm2(unsigned long *);
double rnorm(double,double,unsigned long *);
double rltnorm0(double, unsigned long*);
double rltnorm(double,double, double, unsigned long*);
double rtnorm(double,double, double,double,unsigned long*);
double rgamma(double,double,unsigned long *);
double rinverse_gamma(double,double,unsigned long *);
double fact_ln(int);
int rpois(double,unsigned long *);
void rdirichlet(double*, double *,int,unsigned long *);
double rbeta(double,double,unsigned long *);

#endif //_RANDGEN_H_