# simulation for (1)
### use the full version
library(pscl)
library(mclust)
library(tmvtnorm)
library(DPpackage)
load("adjacency.bin")
load("simu10226.bin")
set.seed(1111)
testcov<-0
for(i in 1:1000){
if(newz[i]==0){
testcov[i]<-rnorm(1,mean=0,sd=0.2)

}else{
testcov[i]<-rnorm(1,mean=0.5,sd=0.2)

}
}

ita0<--0.003581923
ita1<-0.527062225
mbeta0<-1000
alpha0=mbeta0/0.03769248+1
mbeta1<-1000
alpha1=mbeta1/0.03769248+1
mu0<--0.003581923
mu1<-0.527062225
var0=var1=0.03769248


aa<-matrix

adjust_acceptance = function(accept,sgm, target)
{
  y = 1. + 1000.*(accept-target)*(accept-target)*(accept-target);
  if (y < .9)
    y = .9;
  if (y > 1.1)
    y = 1.1;
  sgm = y*sgm;
  return(sgm)
}


expect1<-function(xixi,beta0,beta1){

idx1 = which(xixi==1)
idx0 = which(xixi==0)

results<-beta1*sum(aa[idx1,idx1])+beta0*sum(aa[idx0,idx0])
return(results)
}

myupdate<-function(n,bb0,bb1,pi0,s0,s1,s2){
total<-matrix(rep(0,1000*n),ncol=1000,nrow=n)
zz<-c(rep(c(1,0,0),100),rep(0,700))
flag<-0
#sigma<-matrix(c(s0,0,0, 0,s1,0 ,0,0,s2),nrow=3,ncol=3)
hh<-0
ratio<-0
accept<-0
theta<-matrix(rep(NA,3*n),nrow=n,ncol=3)
res<-matrix(rep(NA,100*n),nrow=n,ncol=100)
final<-matrix(rep(NA,100*n),nrow=n,ncol=100)
theta[1,]<-c(bb0,bb1,pi0)

for(jj in 1:n){


for(num1 in 1:1000){

pro1<-0
pro0<-0
idx = which(aa[num1,]==1)

pro0=sum((zz[idx]==0))
pro1=sum((zz[idx]==1))



log0<-log(pi0)+(2*bb0*pro0-(testcov[num1]-mu0[jj])^2*0.5/var0[jj])-0.5*log(var0[jj])

log1<-log(1-pi0)+(2*bb1*pro1-(testcov[num1]-mu1[jj])^2*0.5/var1[jj])-0.5*log(var1[jj])



p0<-1/(1+exp(log1-log0))
p1<-1-p0

zz[num1]<-sample(c(0,1),1,prob=c(p0,p1))

if(jj==1){total[jj,num1]<-zz[num1]}else{
total[jj,num1]<-total[jj-1,num1]+zz[num1]
}


}
## update theta

mean0<-(var0[jj]*ita0+0.0001*sum(testcov[which(zz==0)]))/(var0[jj]+0.0001*(1000-sum(zz)))
mean1<-(var1[jj]*ita1+0.0001*sum(testcov[which(zz==1)]))/(var1[jj]+0.0001*sum(zz))
variance0<-var0[jj]*0.0001/(var0[jj]+0.0001*(1000-sum(zz)))
variance1<-var1[jj]*0.0001/(var1[jj]+0.0001*sum(zz))
mu0[jj+1]<-rnorm(1,mean=mean0,sd=sqrt(variance0))
mu1[jj+1]<-rnorm(1,mean=mean1,sd=sqrt(variance1))

all0<-alpha0+(1000-sum(zz))*0.5
laa0<-sum((testcov[which(zz==0)]-mu0[jj+1])^2)*0.5+mbeta0
all1<-alpha1+sum(zz)*0.5
laa1<-sum((testcov[which(zz==1)]-mu1[jj+1])^2)*0.5+mbeta1
var0[jj+1]<-rigamma(1,all0,laa0)
var1[jj+1]<-rigamma(1,all1,laa1)



## MH part

idx1 = which(zz==1)
idx0 = which(zz==0)
zstat1<-sum(aa[idx1,idx1])
zstat2<-sum(aa[idx0,idx0])
if(jj>1){
theta[jj,]<--c(1,1,2)
while(theta[jj,3]>1 | theta[jj,3]<0 | theta[jj,1]<0 | theta[jj,2]<0){
#theta[tt,]<-mvrnorm(n = 1, theta[tt-1,],sigma , tol = 1e-6, empirical = FALSE)
theta[jj,] = theta[jj-1,] + c(s0,s1,s2)*rnorm(3,0,1)
}
}


hh[jj]<-log(theta[jj,3])*length(idx0)+log(1-theta[jj,3])*length(idx1)+theta[jj,2]*zstat1+theta[jj,1]*zstat2
temp = matrix(sample(c(0,1),1000,replace=TRUE,prob=c(theta[jj,3],1-theta[jj,3])),nrow=100,ncol=1000)

res[jj,]<-apply(temp,1,expect1,theta[jj,1],theta[jj,2])
final[jj,]<-res[jj,]-hh[jj]
if(jj>1){

scres<-exp(final[jj,]-max(final[jj,]))

oldsc<-exp(final[jj-1,]-max(final[jj,]))

ratio[jj]<-sum(oldsc)/sum(scres)


if(ratio[jj]>1){theta[jj,]<-theta[jj,]
final[jj,]<-final[jj,]
accept[jj]<-1
}else{
alf<-runif(1)
if(ratio[jj]<alf){theta[jj,]<-theta[jj-1,]
final[jj,]<-final[jj-1,]
accept[jj]<-0}else{
theta[jj,]<-theta[jj,]
final[jj,]<-final[jj,]
accept[jj]<-1
}

}
}
if(jj%%25==0)
{
   acptrate = mean(accept[(flag+1):jj])
   s0 = adjust_acceptance(acptrate,s0,0.234)
   s1 = adjust_acceptance(acptrate,s1,0.234)
   s2 = adjust_acceptance(acptrate,s2,0.234)
   flag = jj

}




}

return(list(total,theta,accept,mu0,mu1,var0,var1))
}


set.seed(1111)
results<-myupdate(10000,3,5,0.9,0.1,0.1,0.1)
save(results,file="simu10321.bin")